## nvidia-settings 470.74

=== debian/changelog ===
nvidia-settings (470.74-0.1~mx19+1) mx; urgency=medium

  * Import new upstream release 470.74.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 01 Oct 2021 11:10:15 -0700

=== debian/control ===
Source: nvidia-settings
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders: Andreas Beckmann <anbe@debian.org>, Luca Boccassi <bluca@debian.org>
Build-Depends: debhelper-compat (= 13),
               libgl1-mesa-dev | libgl-dev,
               libgtk-3-dev,
               libjansson-dev,
               libvdpau-dev (>= 0.9),
               libxv-dev,
               libxxf86vm-dev,
               m4,
               pkg-config,
               xserver-xorg-dev
Build-Conflicts: libxnvctrl-dev
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://download.nvidia.com/XFree86/nvidia-settings/
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-settings
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-settings.git

Package: nvidia-settings
Section: contrib/x11
Architecture: amd64 arm64
Pre-Depends: nvidia-installer-cleanup
Depends: libxnvctrl0 (= ${binary:Version}),
         ${misc:Depends},
         ${nvidia}-alternative,
         ${shlibs:Depends}
Recommends: lib${nvidia}-ml1,
            libgl1-${nvidia}-glvnd-glx,
            ${nvidia}-vdpau-driver
Provides: nvidia-settings-gtk-${nvidia:Version}
Conflicts: nvidia-settings-gtk-${nvidia:Version}
Description: tool for configuring the NVIDIA graphics driver${nvidia:VariantDesc}
 The nvidia-settings utility is a tool for configuring the NVIDIA
 Linux graphics driver.  It operates by communicating with the NVIDIA
 X driver, querying and updating state as appropriate.  This
 communication is done with the NV-CONTROL X extension.
 .
 Values such as brightness and gamma, XVideo attributes, temperature,
 and OpenGL settings can be queried and configured via nvidia-settings.

Package: libxnvctrl0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: NV-CONTROL X extension (runtime library)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.
 .
 This package contains the shared library.

Package: libxnvctrl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libx11-dev, libxnvctrl0 (= ${binary:Version}), ${misc:Depends}
Description: NV-CONTROL X extension (development files)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export NV_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

PKG_CONFIG_XORG_XSERVER_LIBDIR	 = $(shell pkg-config --variable=libdir xorg-server)
CPPFLAGS		+= -DPKG_CONFIG_XORG_XSERVER_LIBDIR='\"$(PKG_CONFIG_XORG_XSERVER_LIBDIR)\"'

export PREFIX		 = /usr
export DO_STRIP		 =
export CC_ONLY_CFLAGS	 = $(CPPFLAGS)
export HOST_CC_ONLY_CFLAGS	 = $(CPPFLAGS)
# reproducible builds: instead of _out/$(uname)_($uname -m) use a fixed directory
export OUTPUTDIR	 = _out/debian

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
export DEBUG		 = 1
endif

export NV_USE_BUNDLED_LIBJANSSON = 0

include debian/rules.defs
NVIDIA_LEGACY		?=
NVIDIA_TESLA		?=
NVIDIA_RELEASE		 = $(DEB_VERSION_UPSTREAM)
variant			 = $(if $(NVIDIA_TESLA),tesla-$(NVIDIA_TESLA),$(if $(NVIDIA_LEGACY),legacy-$(NVIDIA_LEGACY)xx))
variant_description	 = $(if $(NVIDIA_TESLA), (Tesla $(NVIDIA_TESLA) version),$(if $(NVIDIA_LEGACY), ($(NVIDIA_LEGACY)xx legacy version)))
-variant		 = $(if $(variant),-$(variant))
nvidia			 = nvidia$(-variant)
nvidia_private		 = nvidia/$(if $(variant),$(variant),current)
watch_version		?= $(or $(NVIDIA_TESLA),$(NVIDIA_LEGACY))

ALL_CONTROL	:= $(wildcard debian/nvidia-settings.*)
VARIANT_CONTROL	:= $(wildcard debian/nvidia-settings$(-variant).*)
RENAME_CONTROL	 = $(filter-out $(VARIANT_CONTROL),$(ALL_CONTROL))
RENAMED_CONTROL	 = $(patsubst debian/nvidia-settings.%,debian/nvidia-settings$(-variant).%,$(RENAME_CONTROL))
TEMPLATES	:= $(wildcard debian/*.in)
AUTOGEN		+= $(patsubst %.in,%,$(TEMPLATES))
AUTOGEN		+= $(patsubst %.in,%,$(RENAMED_CONTROL))
AUTOGEN		+= debian/substvars
AUTOKEEP	 = debian/watch
AUTOCLEAN	 = $(filter-out $(AUTOKEEP),$(AUTOGEN))


%:
	dh $@

ifeq (,$(filter nvidia-settings,$(shell dh_listpackages)))
override_dh_auto_build: $(AUTOGEN)
	CC_ONLY_CFLAGS="$(CPPFLAGS)" dh_auto_build --sourcedirectory=src/libXNVCtrl

override_dh_auto_install:
else
override_dh_auto_build: $(AUTOGEN)
	CC_ONLY_CFLAGS="$(CPPFLAGS)" dh_auto_build --sourcedirectory=src/libXNVCtrl
	CC_ONLY_CFLAGS="$(CPPFLAGS)" dh_auto_build -O--parallel
	$(MAKE) -C samples

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	install -m 0755 samples/$(OUTPUTDIR)/nv-control-dpy debian/tmp/usr/bin/
	install -d -m 0755 debian/tmp/usr/share/icons/hicolor/128x128/apps/
	install -m 0644 doc/nvidia-settings.png debian/tmp/usr/share/icons/hicolor/128x128/apps/nvidia-settings$(-variant).png
endif

execute_after_dh_auto_clean:
	$(MAKE) -C samples clean
	$(RM) -r doc/_out samples/_out src/_out src/libXNVCtrl/_out
	$(RM) $(AUTOCLEAN)
	$(MAKE) -f debian/rules $(AUTOKEEP)

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'nvidia=$(nvidia)' \
		-V'nvidia:VariantDesc=$(variant_description)' \
		-V'nvidia:Version=$(NVIDIA_RELEASE)'

override_dh_strip:
	dh_strip --no-automatic-dbgsym

# used by dpkg-genchanges
debian/substvars:
	echo 'nvidia:VariantDesc=$(variant_description)' > $@


# Generating control files
debian/%:: debian/%.in debian/rules debian/rules.defs
	perl -p \
		-e 's{#VARIANT#}{$(-variant)}g;' \
		-e 's{#VARIANT_DESC#}{$(variant_description)}g;' \
		-e 's{#PRIVATE#}{$(nvidia_private)}g;' \
		-e 's{#WATCH_VERSION#}{$(watch_version)}g;' \
		< $< > $@

# Renaming control files for variant packaging
ifneq (,$(variant))
nvidia-settings$(-variant).%: nvidia-settings.%
	cp -a $< $@
endif

## nvidia-settings 470.103.01

=== debian/changelog ===
nvidia-settings (470.103.01-1~deb11u1) bullseye; urgency=medium

  * Rebuild for bullseye.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 20 Mar 2022 21:55:14 +0100

nvidia-settings (470.103.01-1) unstable; urgency=medium

  * New upstream release 470.103.01.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 08 Feb 2022 09:45:25 +0100

nvidia-settings (470.94-1) unstable; urgency=medium

  * New upstream release 470.94.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 14 Jan 2022 15:00:24 +0100

nvidia-settings (470.82.00-1) unstable; urgency=medium

  * New upstream release 470.82.00.
  * Bump Standards-Version to 4.6.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 08 Nov 2021 15:33:48 +0100

=== debian/control ===
Source: nvidia-settings
Section: x11
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
 Luca Boccassi <bluca@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 m4,
 libgl1-mesa-dev | libgl-dev,
 libgtk-3-dev,
 libjansson-dev,
 libvdpau-dev (>= 0.9),
 libxv-dev,
 libxxf86vm-dev,
 pkg-config,
 xserver-xorg-dev,
Build-Conflicts:
 libxnvctrl-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://download.nvidia.com/XFree86/nvidia-settings/
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-settings
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-settings.git

Package: nvidia-settings
Section: contrib/x11
Architecture: amd64 arm64
Pre-Depends:
 nvidia-installer-cleanup,
Depends:
 , ${nvidia}-alternative
 , libxnvctrl0 (= ${binary:Version})
 , ${shlibs:Depends}, ${misc:Depends}
Recommends:
 , libgl1-${nvidia}-glvnd-glx
 , ${nvidia}-vdpau-driver
 , lib${nvidia}-ml1
Provides:
 nvidia-settings-gtk-${nvidia:Version},
Conflicts:
 nvidia-settings-gtk-${nvidia:Version},
Description: tool for configuring the NVIDIA graphics driver${nvidia:VariantDesc}
 The nvidia-settings utility is a tool for configuring the NVIDIA
 Linux graphics driver.  It operates by communicating with the NVIDIA
 X driver, querying and updating state as appropriate.  This
 communication is done with the NV-CONTROL X extension.
 .
 Values such as brightness and gamma, XVideo attributes, temperature,
 and OpenGL settings can be queried and configured via nvidia-settings.

Package: libxnvctrl0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Description: NV-CONTROL X extension (runtime library)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.
 .
 This package contains the shared library.

Package: libxnvctrl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxnvctrl0 (= ${binary:Version}),
 libx11-dev,
 ${misc:Depends}
Description: NV-CONTROL X extension (development files)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.

## nvidia-settings 470.129.06

=== debian/changelog ===
nvidia-settings (470.129.06-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 18 Jul 2022 16:06:43 -0700

nvidia-settings (470.129.06-1) unstable; urgency=medium

  * New upstream release 470.129.06.
  * Bump Standards-Version to 4.6.1. No changes needed.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 28 Jun 2022 04:14:03 +0200

nvidia-settings (470.103.01-2) unstable; urgency=medium

  [ Luca Boccassi ]
  * Add salsa-ci.yml.

  [ Helmut Grohne ]
  * Improve cross building: Pass more build tools to make.  (Closes: #1005958)

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on libvdpau-dev.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 14 Apr 2022 16:22:46 +0200

=== debian/control ===
Source: nvidia-settings
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders: Andreas Beckmann <anbe@debian.org>, Luca Boccassi <bluca@debian.org>
Build-Depends: debhelper-compat (= 13),
               libgl1-mesa-dev | libgl-dev,
               libgtk-3-dev,
               libjansson-dev,
               libvdpau-dev,
               libxv-dev,
               libxxf86vm-dev,
               m4,
               pkg-config,
               xserver-xorg-dev
Build-Conflicts: libxnvctrl-dev
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://download.nvidia.com/XFree86/nvidia-settings/
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-settings
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-settings.git

Package: nvidia-settings
Section: contrib/x11
Architecture: amd64 arm64
Pre-Depends: nvidia-installer-cleanup
Depends: libxnvctrl0 (= ${binary:Version}),
         ${misc:Depends},
         ${nvidia}-alternative,
         ${shlibs:Depends}
Recommends: lib${nvidia}-ml1,
            libgl1-${nvidia}-glvnd-glx,
            ${nvidia}-vdpau-driver
Provides: nvidia-settings-gtk-${nvidia:Version}
Conflicts: nvidia-settings-gtk-${nvidia:Version}
Description: tool for configuring the NVIDIA graphics driver${nvidia:VariantDesc}
 The nvidia-settings utility is a tool for configuring the NVIDIA
 Linux graphics driver.  It operates by communicating with the NVIDIA
 X driver, querying and updating state as appropriate.  This
 communication is done with the NV-CONTROL X extension.
 .
 Values such as brightness and gamma, XVideo attributes, temperature,
 and OpenGL settings can be queried and configured via nvidia-settings.

Package: libxnvctrl0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: NV-CONTROL X extension (runtime library)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.
 .
 This package contains the shared library.

Package: libxnvctrl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libx11-dev, libxnvctrl0 (= ${binary:Version}), ${misc:Depends}
Description: NV-CONTROL X extension (development files)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,8 @@
 
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/pkg-info.mk
+DPKG_EXPORT_BUILDTOOLS=1
+include /usr/share/dpkg/buildtools.mk
 
 PKG_CONFIG_XORG_XSERVER_LIBDIR	 = $(shell pkg-config --variable=libdir xorg-server)
 CPPFLAGS		+= -DPKG_CONFIG_XORG_XSERVER_LIBDIR='\"$(PKG_CONFIG_XORG_XSERVER_LIBDIR)\"'

## nvidia-settings 470.141.03

=== debian/changelog ===
nvidia-settings (470.141.03-1~deb11u1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 04 Sep 2022 22:44:57 +0200

nvidia-settings (470.141.03-1~deb11u1) bullseye; urgency=medium

  * Rebuild for bullseye.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 02 Sep 2022 10:58:58 +0200

nvidia-settings (470.141.03-1) unstable; urgency=medium

  * New upstream release 470.141.03.
    - Fixed a bug that prevented nvidia-settings from accurately reflecting
      changes to some configuration properties.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 09 Aug 2022 14:45:12 +0200

nvidia-settings (470.103.01-1~deb11u1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 04 Jul 2022 12:59:23 +0200

nvidia-settings (460.32.03-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 20 Jan 2021 15:23:26 +0100

nvidia-settings (450.66-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 29 Sep 2020 23:08:02 +0200

=== debian/control ===
Source: nvidia-settings
Section: x11
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
 Luca Boccassi <bluca@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 m4,
 libgl1-mesa-dev | libgl-dev,
 libgtk-3-dev,
 libjansson-dev,
 libvdpau-dev,
 libxv-dev,
 libxxf86vm-dev,
 pkg-config,
 xserver-xorg-dev,
Build-Conflicts:
 libxnvctrl-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://download.nvidia.com/XFree86/nvidia-settings/
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-settings
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-settings.git

Package: nvidia-settings
Section: contrib/x11
Architecture: amd64 arm64
Pre-Depends:
 nvidia-installer-cleanup,
Depends:
 , ${nvidia}-alternative
 , libxnvctrl0 (= ${binary:Version})
 , ${shlibs:Depends}, ${misc:Depends}
Recommends:
 , libgl1-${nvidia}-glvnd-glx
 , ${nvidia}-vdpau-driver
 , lib${nvidia}-ml1
Provides:
 nvidia-settings-gtk-${nvidia:Version},
Conflicts:
 nvidia-settings-gtk-${nvidia:Version},
Description: tool for configuring the NVIDIA graphics driver${nvidia:VariantDesc}
 The nvidia-settings utility is a tool for configuring the NVIDIA
 Linux graphics driver.  It operates by communicating with the NVIDIA
 X driver, querying and updating state as appropriate.  This
 communication is done with the NV-CONTROL X extension.
 .
 Values such as brightness and gamma, XVideo attributes, temperature,
 and OpenGL settings can be queried and configured via nvidia-settings.

Package: libxnvctrl0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Description: NV-CONTROL X extension (runtime library)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.
 .
 This package contains the shared library.

Package: libxnvctrl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxnvctrl0 (= ${binary:Version}),
 libx11-dev,
 ${misc:Depends}
Description: NV-CONTROL X extension (development files)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.

## nvidia-settings 470.239.06

=== debian/changelog ===
nvidia-settings (470.239.06-1) bullseye; urgency=medium

  * New upstream release 470.141.03.
  * Build for ppc64el.
  * Upload to bullseye.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 24 Apr 2024 05:22:30 +0200

=== debian/control ===
--- 
+++ 
@@ -26,7 +26,7 @@
 
 Package: nvidia-settings
 Section: contrib/x11
-Architecture: amd64 arm64
+Architecture: amd64 arm64 ppc64el
 Pre-Depends:
  nvidia-installer-cleanup,
 Depends:

=== debian/rules ===
--- 
+++ 
@@ -83,9 +83,6 @@
 		-V'nvidia:VariantDesc=$(variant_description)' \
 		-V'nvidia:Version=$(NVIDIA_RELEASE)'
 
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
-
 # used by dpkg-genchanges
 debian/substvars:
 	echo 'nvidia:VariantDesc=$(variant_description)' > $@

## nvidia-settings 510.47.03

=== Makefile ===
#
# nvidia-settings: A tool for configuring the NVIDIA X driver on Unix
# and Linux systems.
#
# Copyright (C) 2008-2012 NVIDIA Corporation.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms and conditions of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses>.
#

.PHONY: all clean clobber install

all clean clobber install:
	@$(MAKE) -C src  $@
	@$(MAKE) -C samples $@
	@$(MAKE) -C doc $@

=== src/Makefile ===
#
# nvidia-settings: A tool for configuring the NVIDIA X driver on Unix
# and Linux systems.
#
# Copyright (C) 2008-2012 NVIDIA Corporation.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms and conditions of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses>.
#


##############################################################################
# include common variables and functions
##############################################################################

UTILS_MK_DIR ?= ..

include $(UTILS_MK_DIR)/utils.mk

XNVCTRL_DIR ?= ../src/libXNVCtrl

include $(XNVCTRL_DIR)/xnvctrl.mk

##############################################################################
# The calling Makefile may export any of the following variables; we
# assign default values if they are not exported by the caller
##############################################################################

PKG_CONFIG            ?= pkg-config

ifndef GTK2_CFLAGS
  GTK2_CFLAGS          := $(shell $(PKG_CONFIG) --cflags gtk+-2.0)
endif

ifndef GTK2_LDFLAGS
  GTK2_LDFLAGS         := -Wl,--no-as-needed $(shell $(PKG_CONFIG) --libs gtk+-2.0)
endif

ifndef GTK3_AVAILABLE
  GTK3_AVAILABLE := $(shell $(PKG_CONFIG) --exists gtk+-3.0 && echo 1)
endif

ifeq (1,$(GTK3_AVAILABLE))
  ifndef GTK3_CFLAGS
    GTK3_CFLAGS          := $(shell $(PKG_CONFIG) --cflags gtk+-3.0)
  endif

  ifndef GTK3_LDFLAGS
    GTK3_LDFLAGS         := -Wl,--no-as-needed $(shell $(PKG_CONFIG) --libs gtk+-3.0)
  endif
else
  GTK3_CFLAGS ?=
  GTK3_LDFLAGS ?=
endif

# If GTK3_CFLAGS is set, try and build GTK3LIB
ifdef GTK3_CFLAGS
  BUILD_GTK3LIB = 1
endif

ifndef VDPAU_CFLAGS
  VDPAU_CFLAGS        := $(shell $(PKG_CONFIG) --cflags vdpau 2> /dev/null)
  ifeq ($(VDPAU_CFLAGS),)
    VDPAU_CFLAGS       = -I /usr/include
  endif
endif

ifndef DBUS_CFLAGS
  DBUS_CFLAGS        := $(shell $(PKG_CONFIG) --cflags dbus-1 2> /dev/null)
  ifeq ($(DBUS_CFLAGS),)
    DBUS_CFLAGS       = -I /usr/include/dbus-1.0/
  endif
endif

# These will be unused if nvidia-settings links dynamically against jansson
ifndef JANSSON_CFLAGS
  JANSSON_CFLAGS  = -Wno-cast-qual
  JANSSON_CFLAGS += -Wno-unused-function
  JANSSON_CFLAGS += -DHAVE_CONFIG_H
  JANSSON_CFLAGS += -Wno-format-truncation
endif

##############################################################################
# The XF86Config-parser, libXNVCtrl, and common-utils directories may
# be in one of two places: either elsewhere in the driver source tree
# when building nvidia-settings as part of the NVIDIA driver build (in
# which case, XNVCTRL_DIR, XNVCTRL_ARCHIVE, XCONFIG_PARSER_DIR,
# COMMON_UTILS_DIR and COMMON_UNIX_DIR should be defined by the calling
# makefile), or directly in the source directory when building from the
# nvidia-settings source tarball (in which case, the below conditional
# assignments should be used)
##############################################################################

XNVCTRL_DIR             ?= libXNVCtrl
XCONFIG_PARSER_DIR      ?= XF86Config-parser
COMMON_UTILS_DIR        ?= common-utils
COMMON_UNIX_DIR         ?= common-unix
VIRTUAL_RESOLUTIONS_DIR ?= $(COMMON_UNIX_DIR)/virtual-resolutions

##############################################################################
# assign variables
##############################################################################

NVIDIA_SETTINGS = $(OUTPUTDIR)/nvidia-settings

NVIDIA_SETTINGS_VERSION := $(NVIDIA_VERSION)

GTK2LIB_NAME = libnvidia-gtk2.so
GTK2LIB_DIR  = $(OUTPUTDIR)/gtk2
GTK2LIB = $(OUTPUTDIR)/$(GTK2LIB_NAME)
GTK2LIB_SONAME = $(GTK2LIB_NAME).$(NVIDIA_SETTINGS_VERSION)

ifdef BUILD_GTK3LIB
  GTK3LIB_NAME = libnvidia-gtk3.so
  GTK3LIB_DIR  = $(OUTPUTDIR)/gtk3
  GTK3LIB = $(OUTPUTDIR)/$(GTK3LIB_NAME)
  GTK3LIB_SONAME = $(GTK3LIB_NAME).$(NVIDIA_SETTINGS_VERSION)
else
  # This value is empty if we are not building GTK3 so that the
  # nvidia-settings build step has this as an empty dependency.
  GTK3LIB =
endif

CFLAGS += $(XNVCTRL_CFLAGS)

ifeq ($(TARGET_OS),SunOS)
  LDFLAGS += -Wl,-rpath=/usr/X11R6/lib -Wl,--export-dynamic
  LIBS += -lscf
endif

LDFLAGS += $(XNVCTRL_LDFLAGS)


# Some older Linux distributions do not have the dynamic library
# libXxf86vm.so, though some newer Linux distributions do not have the
# static library libXxf86vm.a.  Statically link against libXxf86vm
# when building nvidia-settings within the NVIDIA driver build, but
# dynamically link against libXxf86vm in the public builds.
NV_LINK_LIBXXF86VM_STATICALLY ?= 0

ifneq ($(NV_LINK_LIBXXF86VM_STATICALLY),0)
    LIBS += -Wl,-Bstatic -lXxf86vm -Wl,-Bdynamic
else
    LIBS += -lXxf86vm
endif

# nvidia-settings depends on libjansson >= 2.2.  If NV_USE_BUNDLED_LIBJANSSON is
# set to a non-zero value, then nvidia-settings is linked statically against the
# copy of libjansson bundled in the source tarball; if it is set to 0,
# nvidia-settings is linked dynamically against the copy of libjansson on the
# host system.  By default, nvidia-settings is linked against the bundled copy.
NV_USE_BUNDLED_LIBJANSSON ?= 1

ifeq ($(NV_USE_BUNDLED_LIBJANSSON),0)
    LIBS += -ljansson
endif

# Preferably, we would use pkg-config's "--libs-only-l" and
# "--libs-only-L" options to get separate GTK_LDFLAGS and GTK_LIBS,
# appending them to LDFLAGS and LIBS, respectively.  However, the
# pkg-config(1) man page cautions:
#
#     [...] Note that the union of "--libs-only-l"  and
#     "--libs-only-L"  may be smaller than "--libs", due to flags such
#     as -rdynamic.
#
# So append all of GTK_LDFLAGS to LIBS, so that LIBS can go after
# $(OBJECTS) on the link commandline, causing libraries for linking to
# be named after the objects that depend on those libraries (needed
# for "--as-needed" linker behavior).
LIBS += -lX11 -lXext -lm $(LIBDL_LIBS)

GTK2_LIBS += $(GTK2_LDFLAGS)
GTK3_LIBS += $(GTK3_LDFLAGS)

# Include all the source lists; dist-files.mk will define NVIDIA_SETTINGS_SRC
include src.mk
SRC        += $(NVIDIA_SETTINGS_SRC)

include $(XCONFIG_PARSER_DIR)/src.mk
XCP_SRC    += $(addprefix $(XCONFIG_PARSER_DIR)/,$(XCONFIG_PARSER_SRC))

include $(COMMON_UTILS_DIR)/src.mk
SRC        += $(addprefix $(COMMON_UTILS_DIR)/,$(COMMON_UTILS_SRC))

include $(VIRTUAL_RESOLUTIONS_DIR)/src.mk
SRC        += $(addprefix $(VIRTUAL_RESOLUTIONS_DIR)/,$(VIRTUAL_RESOLUTIONS_SRC))

OBJS        = $(call BUILD_OBJECT_LIST,$(SRC))
XCP_OBJS    = $(call BUILD_OBJECT_LIST,$(XCP_SRC))

GTK2_OBJS    = $(call BUILD_OBJECT_LIST_WITH_DIR,$(GTK_SRC),$(GTK2LIB_DIR))
GTK3_OBJS    = $(call BUILD_OBJECT_LIST_WITH_DIR,$(GTK_SRC),$(GTK3LIB_DIR))
IMAGE_OBJS    = $(addprefix $(OUTPUTDIR)/,$(addsuffix .o,$(notdir $(IMAGE_FILES))))
IMAGE_HEADERS = $(addprefix $(OUTPUTDIR)/,$(addsuffix .h,$(notdir $(IMAGE_FILES))))

CFLAGS     += -I .
CFLAGS     += -I image_data
CFLAGS     += -I $(XNVCTRL_DIR)
CFLAGS     += -I $(XCONFIG_PARSER_DIR)/..
CFLAGS     += -I libXNVCtrlAttributes
CFLAGS     += -I xpm_data

ifneq ($(NV_USE_BUNDLED_LIBJANSSON),0)
  CFLAGS     += -I jansson
endif

CFLAGS     += -I $(COMMON_UTILS_DIR)
CFLAGS     += -I $(VIRTUAL_RESOLUTIONS_DIR)
CFLAGS     += -I $(OUTPUTDIR)
CFLAGS     += $(VDPAU_CFLAGS)
CFLAGS     += $(DBUS_CFLAGS)
CFLAGS     += -DPROGRAM_NAME=\"nvidia-settings\"

$(call BUILD_OBJECT_LIST,$(XCP_SRC)): CFLAGS += -fPIC

$(call BUILD_OBJECT_LIST_WITH_DIR,$(GTK_SRC),$(GTK2LIB_DIR)): \
    CFLAGS += $(GTK2_CFLAGS) -fPIC -I $(XCONFIG_PARSER_DIR)/..

ifdef BUILD_GTK3LIB
  $(call BUILD_OBJECT_LIST_WITH_DIR,$(GTK_SRC),$(GTK3LIB_DIR)): \
      CFLAGS += $(GTK3_CFLAGS) -fPIC -I $(XCONFIG_PARSER_DIR)/..
endif

ifneq ($(NV_USE_BUNDLED_LIBJANSSON),0)
  $(call BUILD_OBJECT_LIST,$(JANSSON_SRC)): CFLAGS += $(JANSSON_CFLAGS)
endif

define BINARY_DATA_HEADER_RULE
  $$(OUTPUTDIR)/$(notdir $(1)).h:
	$(at_if_quiet)$(MKDIR) $$(OUTPUTDIR)
	$(at_if_quiet){ \
	  $$(PRINTF) "extern const char _binary_$(subst .,_,$(notdir $(1)))_start[];\n"; \
	  $$(PRINTF) "extern const char _binary_$(subst .,_,$(notdir $(1)))_end[];\n"; \
	} > $$@
endef

##############################################################################
# build rules
##############################################################################

.PHONY: all install NVIDIA_SETTINGS_install clean clobber

all: $(NVIDIA_SETTINGS) $(GTK2LIB) $(GTK3LIB)

install: NVIDIA_SETTINGS_install NVIDIA_GTKLIB_install

NVIDIA_GTKLIB_install: $(GTK2LIB) $(GTK3LIB)
	$(MKDIR) $(LIBDIR)
	$(INSTALL) $(INSTALL_LIB_ARGS) $(GTK2LIB) \
	    $(LIBDIR)/$(GTK2LIB_SONAME)
ifdef BUILD_GTK3LIB
	$(INSTALL) $(INSTALL_LIB_ARGS) $(GTK3LIB) \
	    $(LIBDIR)/$(GTK3LIB_SONAME)
endif

NVIDIA_SETTINGS_install: $(NVIDIA_SETTINGS)
	$(MKDIR) $(BINDIR)
	$(INSTALL) $(INSTALL_BIN_ARGS) $< $(BINDIR)/$(notdir $<)

$(eval $(call DEBUG_INFO_RULES, $(NVIDIA_SETTINGS)))
$(NVIDIA_SETTINGS).unstripped: $(OBJS) $(LIBXNVCTRL)
	$(call quiet_cmd,LINK) $(CFLAGS) $(LDFLAGS) $(BIN_LDFLAGS) \
	    -rdynamic -o $@ $(OBJS) $(LIBXNVCTRL) $(LIBS)

$(eval $(call DEBUG_INFO_RULES, $(GTK2LIB)))
$(GTK2LIB).unstripped: $(LIBXNVCTRL) $(GTK2_OBJS) $(XCP_OBJS) $(IMAGE_OBJS) $(VERSION_MK)
	$(call quiet_cmd,LINK) -shared $(CFLAGS) $(LDFLAGS) $(BIN_LDFLAGS) \
	    $(LIBXNVCTRL) $(LIBS) $(GTK2_LIBS) \
	    -Wl,--unresolved-symbols=ignore-all -o $@ \
	    -Wl,-soname -Wl,$(GTK2LIB_SONAME) \
	    $(GTK2_OBJS) $(IMAGE_OBJS) $(XCP_OBJS)

ifdef BUILD_GTK3LIB
$(eval $(call DEBUG_INFO_RULES, $(GTK3LIB)))
$(GTK3LIB).unstripped: $(LIBXNVCTRL) $(GTK3_OBJS) $(XCP_OBJS) $(IMAGE_OBJS) $(VERSION_MK)
	$(call quiet_cmd,LINK) -shared $(CFLAGS) $(LDFLAGS)  $(BIN_LDFLAGS) \
	    $(LIBXNVCTRL) $(LIBS) $(GTK3_LIBS) \
	    -Wl,--unresolved-symbols=ignore-all -o $@ \
	    -Wl,-soname -Wl,$(GTK3LIB_SONAME) \
	    $(GTK3_OBJS) $(XCP_OBJS) $(IMAGE_OBJS)
endif

# define the rule to build each object file
$(foreach src,$(SRC),$(eval $(call DEFINE_OBJECT_RULE,TARGET,$(src))))
$(foreach src,$(XCP_SRC),$(eval $(call DEFINE_OBJECT_RULE,TARGET,$(src))))

clean clobber:
	rm -rf $(NVIDIA_SETTINGS) *~ \
		$(OUTPUTDIR)/*.o $(OUTPUTDIR)/*.d \
		$(GTK2LIB) $(GTK3LIB) $(GTK2LIB_DIR) $(GTK3LIB_DIR) \
		$(IMAGE_HEADERS) $(LIBXNVCTRL)

$(foreach src,$(GTK_SRC), \
    $(eval $(call DEFINE_OBJECT_RULE_WITH_DIR,TARGET,$(src),$(GTK2LIB_DIR))))

ifdef BUILD_GTK3LIB
$(foreach src,$(GTK_SRC), \
    $(eval $(call DEFINE_OBJECT_RULE_WITH_DIR,TARGET,$(src),$(GTK3LIB_DIR))))
endif

# Build $(IMAGE_OBJS)
$(foreach png,$(IMAGE_FILES), \
  $(eval $(call READ_ONLY_OBJECT_FROM_FILE_RULE,$(png))))

# Build $(IMAGE_HEADERS)
$(foreach png,$(IMAGE_FILES), \
  $(eval $(call BINARY_DATA_HEADER_RULE,$(png))))
$(GTK2_OBJS): $(IMAGE_HEADERS)
ifdef BUILD_GTK3LIB
  $(GTK3_OBJS): $(IMAGE_HEADERS)
endif

=== debian/changelog ===
nvidia-settings (510.47.03-0ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:10:30 +0000

nvidia-settings (510.47.03-0ubuntu3) noble; urgency=medium

  * Fix dh_gencontrol for t64.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 26 Mar 2024 18:25:54 +0100

nvidia-settings (510.47.03-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 06:23:08 +0000

nvidia-settings (510.47.03-0ubuntu1) jammy; urgency=medium

  * New upstream release (LP: #1960766).
  * debian/rules.defs:
    - Remove final / from the URL
  * debian/patches/series:
    - Drop 07_remove_features_for_legacy.patch.
  * debian/patches/08_add_prime_support.patch:
    - Rebase on 510
  * debian/patches/17_do_not_read_config_on_power_saving_mode.patch:
    - Refresh patch.

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 14 Feb 2022 16:51:41 +0100

nvidia-settings (470.57.01-0ubuntu4) jammy; urgency=medium

  [ Jeremy Szu ]
  * debian/patches/18_remove_power-saving_if_on-demand.patch,
    debian/patches/19_lp1957094-adjust-on-demand-mode-description.patch:
     - Disable the item of power saving mode if on-demand is supported
       (LP: #1957094).
     - Leave the item there because the user might issue 'prime-select
       intel' manually. Thus, leave it there could prevent selection
       confuse.
     - Explain the on-demand mode if driver < 450.

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 03 Feb 2022 16:28:33 +0100

nvidia-settings (470.57.01-0ubuntu3) impish; urgency=medium

  * control: Enable build of nvidia-settings package on riscv64.
    (LP: #1943030)

 -- Alexandre Ghiti <alexandre.ghiti@canonical.com>  Thu, 16 Sep 2021 11:11:52 -0700

nvidia-settings (470.57.01-0ubuntu2) impish; urgency=medium

  * debian/patches/17_do_not_read_config_on_power_saving_mode.patch:
    - Do not read config on Power Saving mode. (LP: #1943160).

 -- Shengyao Xue <shengyao.xue@canonical.com>  Fri, 10 Sep 2021 00:42:38 +0800

nvidia-settings (470.57.01-0ubuntu1) impish; urgency=medium

  * New upstream release (LP: #1933980).

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 12 Jul 2021 16:13:23 +0200

nvidia-settings (465.31-0ubuntu1) impish; urgency=medium

  * New upstream release.
  * debian/patches/12_nostrip.patch,
    debian/patches/14_nvidia-settings.desktop.patch:
    - Refresh the patches.
  * debian/compat, debian/control:
    - Depend on debhelper 10 and update standards.

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 14 Jun 2021 13:08:56 +0200

nvidia-settings (460.73.01-0ubuntu2) impish; urgency=medium

  [ Thomas Ward ]
  * debian/patches/include-Xlib.patch: (LP: #1922583)
    - NVCtrlLib.h uses macros from X11/Xlib.h. Include it.

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 13 May 2021 12:04:49 +0200

nvidia-settings (460.73.01-0ubuntu1) impish; urgency=medium

  * New upstream release.

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 05 May 2021 15:26:22 +0200

nvidia-settings (460.56-0ubuntu1) hirsute; urgency=medium

  * New upstream release.

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 18 Mar 2021 18:24:29 +0100

nvidia-settings (460.39-0ubuntu2) hirsute; urgency=medium

  * debian/patches/08_add_prime_support.patch:
    - Stop the timeout after the child is done.
      Fixes e00eb1b3fbe5d04901fe25f2a0e7332659a82064
      and 6a6445e659806d915dd486417ae2e8c3cc89b1ff
      from https://errors.ubuntu.com.

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 18 Mar 2021 11:50:23 +0100

nvidia-settings (460.39-0ubuntu1) hirsute; urgency=medium

  * New upstream release.
  * debian/patches/link-order.diff,
    debian/patches/12_nostrip.patch,
    debian/patches/05_add_polkit_support.patch,
    debian/patches/06_remove_local_prefix.patch,
    debian/patches/07_remove_features_for_legacy.patch
    debian/patches/10_legacy_vdpau.patch
    debian/patches/11_link_as-needed.patch
    debian/patches/13_libxnvctrl_so_0.patch
    debian/patches/15_clean.patch:
    - Refresh patches.
  * debian/patches/series:
    - Drop 16_gzip-n.patch.
  * debian/patches/08_add_prime_support.patch:
    - Refresh and add support for a progress dialog.

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 03 Feb 2021 18:09:00 +0100

=== debian/control ===
Source: nvidia-settings
Section: x11
Priority: optional
XSBC-Original-Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders: Randall Donald <rdonald@debian.org>
Build-Depends: debhelper (>= 10), dh-exec (>= 0.3), m4, libgtk2.0-dev, libgtk-3-dev, libxext-dev, xutils-dev, libxrandr-dev,
 libgl1-mesa-dev | libgl-dev, libegl1-mesa-dev | libegl-dev, libxxf86vm-dev, libxv-dev, libvdpau-dev, libjansson-dev (>= 2.2), libdbus-1-dev
Build-Conflicts: libxnvctrl-dev
Standards-Version: 4.1.4
Vcs-Git: git://github.com/tseliot/nvidia-settings.git
Vcs-Browser: http://github.com/tseliot/nvidia-settings

Package: nvidia-settings
Section: contrib/x11
Architecture: i386 amd64 armhf arm64 ppc64el riscv64
Depends: pkg-config, screen-resolution-extra (>= 0.18~),
 libvdpau1, ${shlibs:Depends}, ${misc:Depends}
Conflicts: nvidia-settings-binary
Replaces: nvidia-settings-binary
Provides: nvidia-settings-binary
Description:  Tool for configuring the NVIDIA graphics driver
 The nvidia-settings utility is a tool for configuring the NVIDIA
 Linux graphics driver.  It operates by communicating with the NVIDIA
 X driver, querying and updating state as appropriate.  This
 communication is done with the NV-CONTROL X extension.
 .
 Values such as brightness and gamma, XVideo attributes, temperature,
 and OpenGL settings can be queried and configured via nvidia-settings.

Package: libxnvctrl0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Description: NV-CONTROL X extension (runtime library)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.
 .
 This package contains the shared library.

Package: libxnvctrl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxnvctrl0 (= ${binary:Version}),
 ${misc:Depends}
Breaks:
 nvidia-settings (<< 346.35-0ubuntu2~),
Replaces:
 nvidia-settings (<< 346.35-0ubuntu2~),
Description: NV-CONTROL X extension (development files)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.

=== debian/rules ===
#!/usr/bin/make -f
#
# Copyright (C) 2009 Canonical Ltd.
include /usr/share/dpkg/pkg-info.mk

include debian/rules.defs

NVIDIA_RELEASE	 = $(DEB_VERSION_UPSTREAM)

PKG_name    := nvidia-settings

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

get_download_url	= $(HTTPURL_PREFIX)/$(NVIDIA_FILENAME)

export NV_USE_BUNDLED_LIBJANSSON = 0

build: build-arch
build-arch:
	$(MAKE) -C src/libXNVCtrl EXTINCSRC=/usr/include/X11/extensions \
		CFLAGS="$(CFLAGS) -fPIC"
	$(MAKE)

clean:
	-$(MAKE) -C src/libXNVCtrl clean 2>/dev/null
	-$(MAKE) clean
	if [ -e src/XF86Config-parser/Makefile ]; then \
		$(MAKE) -C src/XF86Config-parser clean; \
	fi

	rm -Rf $(CURDIR)/_out */_out

	dh clean

binary-arch:
	#dh_auto_install -- prefix=$(CURDIR)/debian/$(PKG_name)$(PKG_libdir)
	$(MAKE) PREFIX=$(CURDIR)/debian/$(PKG_name)/usr install

	#Run the normal stuff
	dh binary-arch

binary: binary-arch binary-indep ;
	#Run the normal stuff
	dh binary

override_dh_compress:
	dh_compress --exclude=.c --exclude=.mk

override_dh_gencontrol:
	set -ex; \
	if [ -f debian/nvidia-settings.substvars ]; then \
		sed -ri -e 's/(^[^:]*:Depends=)/\1 GTK3 | GTK2, /' \
			-e 's/(GTK2)(.*)(libgtk2.0-0t64 \([^\)]*\))/\3\2/' \
			-e 's/(GTK3)(.*)(libgtk-3-0t64 \([^\)]*\))/\3\2/' \
			debian/nvidia-settings.substvars ; \
		! grep GTK debian/nvidia-settings.substvars ; \
	fi
	dh_gencontrol

override_dh_installexamples:
	dh_installexamples -X"_out" -a

override_dh_auto_install:
	dh_auto_install -- DESTDIR=$(CURDIR)/debian/$(PKG_name)

override_dh_usrlocal:
	rm -Rf $(CURDIR)/debian/$(PKG_name)/usr/local

%:
	dh $@

.PHONY: get-orig-source
get-orig-source:
	wget $(call get_download_url) -O ../$(NVIDIA_TARBALL)

## nvidia-settings 510.85.02

=== debian/changelog ===
nvidia-settings (510.85.02-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 05 Oct 2022 15:25:19 +0200

nvidia-settings (510.85.02-1) experimental; urgency=medium

  * New upstream release 510.85.02.
  * Merge changes from 470.141.03-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 10 Aug 2022 15:29:29 +0200

nvidia-settings (510.73.05-1) experimental; urgency=medium

  * New upstream release 510.73.05.
  * Merge changes from 470.129.06-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 05 Jul 2022 08:10:59 +0200

nvidia-settings (510.68.02-1) experimental; urgency=medium

  * New upstream release 510.68.02.

 -- Luca Boccassi <bluca@debian.org>  Mon, 02 May 2022 17:42:25 +0100

nvidia-settings (510.60.02-1) experimental; urgency=medium

  * New upstream release 510.60.02.

  [ Helmut Grohne ]
  * Improve cross building: Pass more build tools to make. (Closes:
    #1005958)

 -- Luca Boccassi <bluca@debian.org>  Sat, 26 Mar 2022 11:41:46 +0000

nvidia-settings (510.54-1) experimental; urgency=medium

  * New upstream release 510.54.
    - Fixed a bug that caused the nvidia-settings control panel to print
      spurious error messages.

 -- Luca Boccassi <bluca@debian.org>  Mon, 14 Mar 2022 00:02:26 +0000

nvidia-settings (510.47.03-1) experimental; urgency=medium

  * New upstream release 510.47.03.
  * New upstream release 510.39.01.
    - Fixed a bug that caused the nvidia-settings control panel to report
      inaccurate ECC error counts, and completely prevented the reporting
      of aggregate ECC error counts. ECC error counts reported by nvidia-smi
      were not affected.
    - Added a GUI control for setting Image Sharpening values in the app
      profiles page of the nvidia-settings control panel.
    - Added support for nvidia-settings to use NVML for NV-CONTROL attributes.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 08 Feb 2022 11:13:57 +0100

nvidia-settings (495.46-1) experimental; urgency=medium

  * New upstream release 495.46.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 17 Jan 2022 02:48:51 +0100

=== debian/control ===
Source: nvidia-settings
Section: x11
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
 Luca Boccassi <bluca@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 m4,
 libgl-dev,
 libgtk-3-dev,
 libjansson-dev,
 libvdpau-dev,
 libxv-dev,
 libxxf86vm-dev,
 pkg-config,
 xserver-xorg-dev,
Build-Conflicts:
 libxnvctrl-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://download.nvidia.com/XFree86/nvidia-settings/
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-settings
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-settings.git

Package: nvidia-settings
Section: contrib/x11
Architecture: amd64 arm64
Pre-Depends:
 nvidia-installer-cleanup,
Depends:
 , ${nvidia}-alternative
 , libxnvctrl0 (= ${binary:Version})
 , ${shlibs:Depends}, ${misc:Depends}
Recommends:
 , libgl1-${nvidia}-glvnd-glx
 , ${nvidia}-vdpau-driver
 , lib${nvidia}-ml1
Provides:
 nvidia-settings-gtk-${nvidia:Version},
Conflicts:
 nvidia-settings-gtk-${nvidia:Version},
Description: tool for configuring the NVIDIA graphics driver${nvidia:VariantDesc}
 The nvidia-settings utility is a tool for configuring the NVIDIA
 Linux graphics driver.  It operates by communicating with the NVIDIA
 X driver, querying and updating state as appropriate.  This
 communication is done with the NV-CONTROL X extension.
 .
 Values such as brightness and gamma, XVideo attributes, temperature,
 and OpenGL settings can be queried and configured via nvidia-settings.

Package: libxnvctrl0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Description: NV-CONTROL X extension (runtime library)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.
 .
 This package contains the shared library.

Package: libxnvctrl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxnvctrl0 (= ${binary:Version}),
 libx11-dev,
 ${misc:Depends}
Description: NV-CONTROL X extension (development files)
 The NV-CONTROL X extension provides a mechanism for X clients to
 query and set configuration parameters of the NVIDIA X driver.
 State set by the NV-CONTROL X extension is assumed to be persistent
 only for the current server generation.

## nvidia-settings 510.108.03

=== debian/changelog ===
nvidia-settings (510.108.03-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 05 Jan 2023 16:48:37 -0800

nvidia-settings (510.108.03-1) unstable; urgency=medium

  * New upstream release 510.108.03.
  * Bump Standards-Version to 4.6.2. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 05 Jan 2023 13:54:35 +0100

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export NV_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
DPKG_EXPORT_BUILDTOOLS=1
include /usr/share/dpkg/buildtools.mk

PKG_CONFIG_XORG_XSERVER_LIBDIR	 = $(shell pkg-config --variable=libdir xorg-server)
CPPFLAGS		+= -DPKG_CONFIG_XORG_XSERVER_LIBDIR='\"$(PKG_CONFIG_XORG_XSERVER_LIBDIR)\"'

export PREFIX		 = /usr
export DO_STRIP		 =
export CC_ONLY_CFLAGS	 = $(CPPFLAGS)
export HOST_CC_ONLY_CFLAGS	 = $(CPPFLAGS)
# reproducible builds: instead of _out/$(uname)_($uname -m) use a fixed directory
export OUTPUTDIR	 = _out/debian

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
export DEBUG		 = 1
endif

export NV_USE_BUNDLED_LIBJANSSON = 0

include debian/rules.defs
NVIDIA_LEGACY		?=
NVIDIA_TESLA		?=
NVIDIA_RELEASE		 = $(DEB_VERSION_UPSTREAM)
variant			 = $(if $(NVIDIA_TESLA),tesla-$(NVIDIA_TESLA),$(if $(NVIDIA_LEGACY),legacy-$(NVIDIA_LEGACY)xx))
variant_description	 = $(if $(NVIDIA_TESLA), (Tesla $(NVIDIA_TESLA) version),$(if $(NVIDIA_LEGACY), ($(NVIDIA_LEGACY)xx legacy version)))
-variant		 = $(if $(variant),-$(variant))
nvidia			 = nvidia$(-variant)
nvidia_private		 = nvidia/$(if $(variant),$(variant),current)
watch_version		?= $(or $(NVIDIA_TESLA),$(NVIDIA_LEGACY))

ALL_CONTROL	:= $(wildcard debian/nvidia-settings.*)
VARIANT_CONTROL	:= $(wildcard debian/nvidia-settings$(-variant).*)
RENAME_CONTROL	 = $(filter-out $(VARIANT_CONTROL),$(ALL_CONTROL))
RENAMED_CONTROL	 = $(patsubst debian/nvidia-settings.%,debian/nvidia-settings$(-variant).%,$(RENAME_CONTROL))
TEMPLATES	:= $(wildcard debian/*.in)
AUTOGEN		+= $(patsubst %.in,%,$(TEMPLATES))
AUTOGEN		+= $(patsubst %.in,%,$(RENAMED_CONTROL))
AUTOGEN		+= debian/substvars
AUTOKEEP	 = debian/watch
AUTOCLEAN	 = $(filter-out $(AUTOKEEP),$(AUTOGEN))


%:
	dh $@

ifeq (,$(filter nvidia-settings,$(shell dh_listpackages)))
override_dh_auto_build: $(AUTOGEN)
	CC_ONLY_CFLAGS="$(CPPFLAGS)" dh_auto_build --sourcedirectory=src/libXNVCtrl

override_dh_auto_install:
else
override_dh_auto_build: $(AUTOGEN)
	CC_ONLY_CFLAGS="$(CPPFLAGS)" dh_auto_build --sourcedirectory=src/libXNVCtrl
	CC_ONLY_CFLAGS="$(CPPFLAGS)" dh_auto_build -O--parallel
	$(MAKE) -C samples

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	install -m 0755 samples/$(OUTPUTDIR)/nv-control-dpy debian/tmp/usr/bin/
	install -d -m 0755 debian/tmp/usr/share/icons/hicolor/128x128/apps/
	install -m 0644 doc/nvidia-settings.png debian/tmp/usr/share/icons/hicolor/128x128/apps/nvidia-settings$(-variant).png
endif

execute_after_dh_auto_clean:
	$(MAKE) -C samples clean
	$(RM) -r doc/_out samples/_out src/_out src/libXNVCtrl/_out
	$(RM) $(AUTOCLEAN)
	$(MAKE) -f debian/rules $(AUTOKEEP)

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'nvidia=$(nvidia)' \
		-V'nvidia:VariantDesc=$(variant_description)' \
		-V'nvidia:Version=$(NVIDIA_RELEASE)'

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

# used by dpkg-genchanges
debian/substvars:
	echo 'nvidia:VariantDesc=$(variant_description)' > $@


# Generating control files
debian/%:: debian/%.in debian/rules debian/rules.defs
	perl -p \
		-e 's{#VARIANT#}{$(-variant)}g;' \
		-e 's{#VARIANT_DESC#}{$(variant_description)}g;' \
		-e 's{#PRIVATE#}{$(nvidia_private)}g;' \
		-e 's{#WATCH_VERSION#}{$(watch_version)}g;' \
		< $< > $@

# Renaming control files for variant packaging
ifneq (,$(variant))
nvidia-settings$(-variant).%: nvidia-settings.%
	cp -a $< $@
endif
